# Class TrustManagerFactorySpi

java.lang.Object
javax.net.ssl.TrustManagerFactorySpi

public abstract class TrustManagerFactorySpi extends Object
This class defines the Service Provider Interface (SPI) for the `TrustManagerFactory` class.

All the abstract methods in this class must be implemented by each cryptographic service provider who wishes to supply the implementation of a particular trust manager factory.

Since:
  1.4
See Also:
  - `TrustManagerFactory`
  - `TrustManager`

## Constructor Summary

Constructors
Constructor
Description
`TrustManagerFactorySpi()`
Constructor for subclasses to call.

## Method Summary

Modifier and Type
Method
Description
`protected abstract TrustManager[]`
`engineGetTrustManagers()`
Returns one trust manager for each type of trust material.
`protected abstract void`
`engineInit(KeyStore ks)`
Initializes this factory with a source of certificate authorities and related trust material.
`protected abstract void`
`engineInit(ManagerFactoryParameters spec)`
Initializes this factory with a source of provider-specific key material.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### TrustManagerFactorySpi

public TrustManagerFactorySpi()
Constructor for subclasses to call.

## Method Details

### engineInit

protected abstract void engineInit(KeyStore ks) throws KeyStoreException
Initializes this factory with a source of certificate authorities and related trust material.

Parameters:
  `ks` - the key store or null
Throws:
  `KeyStoreException` - if this operation fails
See Also:
  - `TrustManagerFactory.init(KeyStore)`

### engineInit

protected abstract void engineInit(ManagerFactoryParameters spec) throws InvalidAlgorithmParameterException
Initializes this factory with a source of provider-specific key material.

In some cases, initialization parameters other than a keystore may be needed by a provider. Users of that particular provider are expected to pass an implementation of the appropriate `ManagerFactoryParameters` as defined by the provider. The provider can then call the specified methods in the `ManagerFactoryParameters` implementation to obtain the needed information.

Parameters:
  `spec` - an implementation of a provider-specific parameter specification
Throws:
  `InvalidAlgorithmParameterException` - if there is problem with the parameters
See Also:
  - `TrustManagerFactory.init(ManagerFactoryParameters spec)`

### engineGetTrustManagers

protected abstract TrustManager[] engineGetTrustManagers()
Returns one trust manager for each type of trust material.

Returns:
  the trust managers
Throws:
  `IllegalStateException` - if the factory is not initialized.